//
//  firePlugIn.h
//  fire
//
//  Created by Dustin O'Connor on 3/18/10.
//  Copyright (c) 2010 d0cut0uch. All rights reserved.
//

#import <Quartz/Quartz.h>
#import <Accelerate/Accelerate.h>
#import <QuartzCore/QuartzCore.h>





@interface firePlugIn : QCPlugIn
{
	CALayer *rootLayer;
	CAEmitterLayer *fireEmitter;
	CAEmitterLayer* smokeEmitter;
	id imageView;

}


@property(assign) id<QCPlugInInputImageSource> inputFireImage;
@property(assign) id<QCPlugInInputImageSource> inputSmokeImage;
@property 	NSUInteger inputWidth;
@property NSUInteger inputHeight;
@property 	NSUInteger inputPixWidth;
@property NSUInteger inputPixHeight;
@property 	NSUInteger inputXpos;
@property NSUInteger inputYpos;
@property NSUInteger inputZpos;
@property 	NSUInteger inputAngle;
@property NSUInteger inputEmitPixelXposFire;
@property NSUInteger inputEmitPixelYposFire;
@property NSUInteger inputEmitPixelXposSmoke;
@property NSUInteger inputEmitPixelYposSmoke;
@property(assign) CGColorRef inputColor;
@property(assign) CGColorRef inputSmokeColor;
@property(assign) CGColorRef inputFireColor;
@property 	double inputGrow;
@property  NSUInteger inputFireEmitterSizeWidth;
@property  NSUInteger inputFireEmitterSizeHeight;
@property  NSUInteger inputSmokeEmitterSizeWidth;
@property  NSUInteger inputSmokeEmitterSizeHeight;
@property double inputFireEmissionLongitude;
@property double inputFireBirthRate;
@property double inputFireVelocity;
@property double inputFireVelocityRange;
@property double inputFireEmissionRange;
@property double inputFireXAcceleration;
@property double inputFireYAcceleration;
@property double inputFireZAcceleration;
@property double inputFireScaleSpeed;
@property double inputFireScale;
@property double inputFireAlphaSpeed;
@property double inputFireLifeTime;
@property double inputFireLifeTimeRange;
@property double inputFireSpin;
@property double inputFireSpinRange;
@property double inputSmokeEmissionLongitude;
@property double inputSmokeBirthRate;
@property double inputSmokeVelocity;
@property double inputSmokeVelocityRange;
@property double inputSmokeEmissionRange;
@property double inputSmokeXAcceleration;
@property double inputSmokeYAcceleration;
@property double inputSmokeZAcceleration;
@property double inputSmokeScaleSpeed;
@property double inputSmokeScale;
@property double inputSmokeAlphaSpeed;
@property double inputSmokeLifeTime;
@property double inputSmokeLifeTimeRange;
@property double inputSmokeSpin;
@property double inputSmokeSpinRange;

/*
-(void)recursivelyRenderInContext:(CGContextRef)context;

*/

@end
