//
//  firePlugIn.m
//  fire
//
//  Created by Dustin O'Connor on 3/18/10.
//  Copyright (c) 2010 d0cut0uch. All rights reserved.
//

/* It's highly recommended to use CGL macros instead of changing the current context for plug-ins that perform OpenGL rendering */
#import <OpenGL/CGLMacro.h>

#import "firePlugIn.h"

#define	kQCPlugIn_Name			@"fire"
#define	kQCPlugIn_Description		@"fire by: do'connor. this plugin utilizes core animation emiiters to create fire and smoke or other gas like particle states "





@implementation firePlugIn


@dynamic inputSmokeImage;
@dynamic inputFireImage;
@dynamic inputSmokeColor;
@dynamic inputColor;
@dynamic inputFireColor;
@dynamic inputHeight;
@dynamic inputWidth;
@dynamic inputPixHeight;
@dynamic inputPixWidth;
@dynamic inputXpos;
@dynamic inputYpos;
@dynamic inputZpos;
@dynamic inputAngle;
@dynamic inputGrow;
@dynamic inputEmitPixelYposFire;
@dynamic inputEmitPixelXposFire;
@dynamic inputEmitPixelYposSmoke;
@dynamic inputEmitPixelXposSmoke;
@dynamic inputFireEmitterSizeWidth;
@dynamic inputFireEmitterSizeHeight;
@dynamic inputSmokeEmitterSizeWidth;
@dynamic inputSmokeEmitterSizeHeight;
@dynamic inputFireEmissionLongitude;
@dynamic inputFireBirthRate;
@dynamic inputFireVelocity;
@dynamic inputFireVelocityRange;
@dynamic inputFireEmissionRange;
@dynamic inputFireXAcceleration;
@dynamic inputFireYAcceleration;
@dynamic inputFireZAcceleration;
@dynamic inputFireScaleSpeed;
@dynamic inputFireScale;
@dynamic inputFireAlphaSpeed;
@dynamic inputFireLifeTime;
@dynamic inputFireLifeTimeRange;
@dynamic inputFireSpin;
@dynamic inputFireSpinRange;
@dynamic inputSmokeEmissionLongitude;
@dynamic inputSmokeBirthRate;
@dynamic inputSmokeVelocity;
@dynamic inputSmokeVelocityRange;
@dynamic inputSmokeEmissionRange;
@dynamic inputSmokeXAcceleration;
@dynamic  inputSmokeYAcceleration;
@dynamic inputSmokeZAcceleration;
@dynamic inputSmokeScaleSpeed;
@dynamic inputSmokeScale;
@dynamic inputSmokeAlphaSpeed;
@dynamic inputSmokeLifeTime;
@dynamic inputSmokeLifeTimeRange;
@dynamic inputSmokeSpin;
@dynamic inputSmokeSpinRange;



/*
Here you need to declare the input / output properties as dynamic as Quartz Composer will handle their implementation
@dynamic inputFoo, outputBar;
*/

+ (NSDictionary*) attributes
{

	return [NSDictionary dictionaryWithObjectsAndKeys:kQCPlugIn_Name, QCPlugInAttributeNameKey, kQCPlugIn_Description, QCPlugInAttributeDescriptionKey, nil];
}

+ (NSDictionary*) attributesForPropertyPortWithKey:(NSString*)key
{
	
		//global default key values
	
	if([key isEqualToString:@"inputXpos"])
		return [NSDictionary dictionaryWithObjectsAndKeys:
				@"X Position", QCPortAttributeNameKey,
				@"0",QCPortAttributeDefaultValueKey,
				nil];
	if([key isEqualToString:@"inputYpos"])
		return [NSDictionary dictionaryWithObjectsAndKeys:
				@"Y Position", QCPortAttributeNameKey,
				@"0",QCPortAttributeDefaultValueKey,
				nil];
	if([key isEqualToString:@"inputZpos"])
		return [NSDictionary dictionaryWithObjectsAndKeys:
				@"Z Position", QCPortAttributeNameKey,
				@"0",QCPortAttributeDefaultValueKey,
				nil];
	if([key isEqualToString:@"inputAngle"])
		return [NSDictionary dictionaryWithObjectsAndKeys:
				@"Rotation Angle", QCPortAttributeNameKey,
				@"0",QCPortAttributeDefaultValueKey,
				nil];
	
	if([key isEqualToString:@"inputColor"])
		return [NSDictionary dictionaryWithObjectsAndKeys:
				@"Fire Color", QCPortAttributeNameKey,
				@"0",QCPortAttributeDefaultValueKey,nil];
	
	if([key isEqualToString:@"inputPixHeight"])
		return [NSDictionary dictionaryWithObjectsAndKeys:
				@"Height in Pix", QCPortAttributeNameKey, 
				[NSNumber numberWithUnsignedInteger:480], 
				QCPortAttributeDefaultValueKey,nil];
	
	if([key isEqualToString:@"inputPixWidth"])
		return [NSDictionary dictionaryWithObjectsAndKeys:
				@"Width in Pix", QCPortAttributeNameKey, 
				[NSNumber numberWithUnsignedInteger:720], 
				QCPortAttributeDefaultValueKey,nil];
	
	if([key isEqualToString:@"inputWidth"])
		return [NSDictionary dictionaryWithObjectsAndKeys:
				@"Width in Units", QCPortAttributeNameKey, 
				[NSNumber numberWithFloat:2], 
				QCPortAttributeDefaultValueKey,nil];
	if([key isEqualToString:@"inputHeight"])
		return [NSDictionary dictionaryWithObjectsAndKeys:
				@"Height in Units", QCPortAttributeNameKey, 
				[NSNumber numberWithFloat:1.6], 
				QCPortAttributeDefaultValueKey,nil];
	
	if([key isEqualToString:@"inputGrow"])
		return [NSDictionary dictionaryWithObjectsAndKeys:
				@"Gas", QCPortAttributeNameKey,[NSNumber numberWithUnsignedInteger:1], QCPortAttributeMinimumValueKey,
				[NSNumber numberWithUnsignedInteger:64], QCPortAttributeDefaultValueKey,
				[NSNumber numberWithUnsignedInteger:200],QCPortAttributeMaximumValueKey,nil];
	
		//fire default key values
	if([key isEqualToString:@"inputFireImage"])
		return [NSDictionary dictionaryWithObjectsAndKeys:
				@"Fire Image", QCPortAttributeNameKey, nil];
	
	if([key isEqualToString:@"inputFireColor"])
		return [NSDictionary dictionaryWithObjectsAndKeys:
				@"Fire Color", QCPortAttributeNameKey,nil];
	
	if([key isEqualToString:@"inputEmitPixelXposFire"])
		return [NSDictionary dictionaryWithObjectsAndKeys:
				@"Fire Emitter Pixel Point X", QCPortAttributeNameKey, 
				[NSNumber numberWithUnsignedInteger:225], 
				QCPortAttributeDefaultValueKey,nil];
	
	if([key isEqualToString:@"inputEmitPixelYposFire"])
		return [NSDictionary dictionaryWithObjectsAndKeys:
				@"Fire Emitter Pixel Point Y ", QCPortAttributeNameKey, 
				[NSNumber numberWithUnsignedInteger:50], 
				QCPortAttributeDefaultValueKey,nil];
	
	if([key isEqualToString:@"inputFireEmitterSizeWidth"])
		return [NSDictionary dictionaryWithObjectsAndKeys:
				@"Fire Emitter Size Width", QCPortAttributeNameKey, 
				[NSNumber numberWithUnsignedInteger:0], 
				QCPortAttributeDefaultValueKey,nil];

	
	if([key isEqualToString:@"inputFireEmitterSizeHeight"])
		return [NSDictionary dictionaryWithObjectsAndKeys:
				@"Fire Emitter Size Width", QCPortAttributeNameKey, 
				[NSNumber numberWithUnsignedInteger:0],
				QCPortAttributeDefaultValueKey,nil];

	
	if([key isEqualToString:@"inputFireEmissionLongitude"])
		return [NSDictionary dictionaryWithObjectsAndKeys:
				@"Fire Emission Longitude", QCPortAttributeNameKey, 
				[NSNumber numberWithFloat:M_PI], QCPortAttributeDefaultValueKey,nil];


	
	if([key isEqualToString:@"inputFireBirthRate"])
		return [NSDictionary dictionaryWithObjectsAndKeys:
				@"Fire Birth Rate", QCPortAttributeNameKey, 
				[NSNumber numberWithFloat:0], QCPortAttributeDefaultValueKey,nil];

	
	if([key isEqualToString:@"inputFireLifeTime"])
		return [NSDictionary dictionaryWithObjectsAndKeys:
				@"Fire Lifetime", QCPortAttributeNameKey, 
				[NSNumber numberWithFloat:0], QCPortAttributeDefaultValueKey,nil];

	
	if([key isEqualToString:@"inputFireVelocity"])
		return [NSDictionary dictionaryWithObjectsAndKeys:
				@"Fire Velocity", QCPortAttributeNameKey, 
				[NSNumber numberWithFloat:80], QCPortAttributeDefaultValueKey,nil];

	
	if([key isEqualToString:@"nputFireVelocityRange"])
		return [NSDictionary dictionaryWithObjectsAndKeys:
				@"Fire Velocity Range", QCPortAttributeNameKey, 
				[NSNumber numberWithFloat:30], QCPortAttributeDefaultValueKey,nil];

	
	if([key isEqualToString:@"inputFireEmissionRange"])
		return [NSDictionary dictionaryWithObjectsAndKeys:
				@"Fire Emission Range", QCPortAttributeNameKey, 
				[NSNumber numberWithFloat:1.1], QCPortAttributeDefaultValueKey,nil];

	
	if([key isEqualToString:@"inputFireXAcceleration"])
		return [NSDictionary dictionaryWithObjectsAndKeys:
				@"Fire Acceleration X", QCPortAttributeNameKey, 
				[NSNumber numberWithFloat:0], QCPortAttributeDefaultValueKey,nil];

	
	if([key isEqualToString:@"inputFireYAcceleration"])
		return [NSDictionary dictionaryWithObjectsAndKeys:
				@"Fire Acceleration Y", QCPortAttributeNameKey, 
				[NSNumber numberWithFloat:200], QCPortAttributeDefaultValueKey,nil];

	
	if([key isEqualToString:@"inputFireZAcceleration"])
		return [NSDictionary dictionaryWithObjectsAndKeys:
				@"Fire Acceleration Z", QCPortAttributeNameKey, 
				[NSNumber numberWithFloat:0], QCPortAttributeDefaultValueKey,nil];

	
	if([key isEqualToString:@"inputFireScaleSpeed"])
		return [NSDictionary dictionaryWithObjectsAndKeys:
				@"Fire Scale Speed", QCPortAttributeNameKey, 
				[NSNumber numberWithFloat:0.3], QCPortAttributeDefaultValueKey,nil];

	
	if([key isEqualToString:@"inputFireScale"])
		return [NSDictionary dictionaryWithObjectsAndKeys:
				@"Fire Scale", QCPortAttributeNameKey, 
				[NSNumber numberWithFloat:0.3], QCPortAttributeDefaultValueKey,nil];

	
	if([key isEqualToString:@"inputFireAlphaSpeed"])
		return [NSDictionary dictionaryWithObjectsAndKeys:
				@"Fire Alpha Speed", QCPortAttributeNameKey, 
				[NSNumber numberWithFloat:-0.24], QCPortAttributeDefaultValueKey,nil];

	
	if([key isEqualToString:@"inputFireSpinRange"])
		return [NSDictionary dictionaryWithObjectsAndKeys:
				@"Fire Spin Range", QCPortAttributeNameKey, 
				[NSNumber numberWithFloat:24], QCPortAttributeDefaultValueKey,nil];

	
	if([key isEqualToString:@"inputFireSpin"])
		return [NSDictionary dictionaryWithObjectsAndKeys:
				@"Fire Spin", QCPortAttributeNameKey, 
				[NSNumber numberWithFloat:0], QCPortAttributeDefaultValueKey,nil];

	

	
		//smoke default keys
	
	if([key isEqualToString:@"inputSmokeImage"])
		return [NSDictionary dictionaryWithObjectsAndKeys:
				@"Smoke Image", QCPortAttributeNameKey, nil];
	
	
	if([key isEqualToString:@"inputSmokeColor"])
		return [NSDictionary dictionaryWithObjectsAndKeys:
				@"Smoke Color", QCPortAttributeNameKey,
				nil];
	
	if([key isEqualToString:@"inputEmitPixelXposSmoke"])
		return [NSDictionary dictionaryWithObjectsAndKeys:
				@"Smoke Emitter Pixel Point X ", QCPortAttributeNameKey, 
				[NSNumber numberWithUnsignedInteger:225], QCPortAttributeDefaultValueKey,nil];

	
	if([key isEqualToString:@"inputEmitPixelYposSmoke"])
		return [NSDictionary dictionaryWithObjectsAndKeys:
				@"Smoke Emitter Pixel Point Y", QCPortAttributeNameKey, 
				[NSNumber numberWithUnsignedInteger:50], QCPortAttributeDefaultValueKey,nil];

	
	if([key isEqualToString:@"inputSmokeEmissionLongitude"])
		return [NSDictionary dictionaryWithObjectsAndKeys:
				@"Smoke Emission Longitude", QCPortAttributeNameKey, 
				[NSNumber numberWithFloat:M_PI/2], QCPortAttributeDefaultValueKey,nil];

	
	if([key isEqualToString:@"inputSmokeBirthRate"])
		return [NSDictionary dictionaryWithObjectsAndKeys:
				@"Smoke Birth Rate", QCPortAttributeNameKey, 
				[NSNumber numberWithFloat:11], QCPortAttributeDefaultValueKey,nil];

	
	if([key isEqualToString:@"inputSmokeLifeTime"])
		return [NSDictionary dictionaryWithObjectsAndKeys:
				@"Smoke Lifetime", QCPortAttributeNameKey, 
				[NSNumber numberWithFloat:0], QCPortAttributeDefaultValueKey,nil];

	
	if([key isEqualToString:@"inputSmokeLifeTimeRange"])
		return [NSDictionary dictionaryWithObjectsAndKeys:
				@"Smoke Lifetime Range", QCPortAttributeNameKey, 
				[NSNumber numberWithFloat:0], QCPortAttributeDefaultValueKey,nil];

	
	if([key isEqualToString:@"inputSmokeVelocity"])
		return [NSDictionary dictionaryWithObjectsAndKeys:
				@"Smoke Velocity", QCPortAttributeNameKey, 
				[NSNumber numberWithFloat:40], QCPortAttributeDefaultValueKey,nil];

	
	if([key isEqualToString:@"inputSmokeVelocityRange"])
		return [NSDictionary dictionaryWithObjectsAndKeys:
				@"Smoke Velocity Range", QCPortAttributeNameKey, 
				[NSNumber numberWithFloat:20], QCPortAttributeDefaultValueKey,nil];

	
	if([key isEqualToString:@"inputSmokeEmissionRange"])
		return [NSDictionary dictionaryWithObjectsAndKeys:
				@"Smoke Emission Range", QCPortAttributeNameKey, 
				[NSNumber numberWithFloat:M_PI/4],QCPortAttributeDefaultValueKey,nil];
	
	if([key isEqualToString:@"inputSmokeXAcceleration"])
		return [NSDictionary dictionaryWithObjectsAndKeys:
				@"Fire Acceleration X", QCPortAttributeNameKey, 
				[NSNumber numberWithFloat:0], QCPortAttributeDefaultValueKey,nil];

	
	if([key isEqualToString:@"inputSmokeYAcceleration"])
		return [NSDictionary dictionaryWithObjectsAndKeys:
				@"Smoke Acceleration Y", QCPortAttributeNameKey, 
				[NSNumber numberWithFloat:160], QCPortAttributeDefaultValueKey,nil];

	
	if([key isEqualToString:@"inputSmokeZAcceleration"])
		return [NSDictionary dictionaryWithObjectsAndKeys:
				@"SmokeAcceleration Z", QCPortAttributeNameKey, 
				[NSNumber numberWithFloat:0], QCPortAttributeDefaultValueKey,nil];

	
	if([key isEqualToString:@"inputSmokeScaleSpeed"])
		return [NSDictionary dictionaryWithObjectsAndKeys:
				@"Smoke Scale Speed", QCPortAttributeNameKey, 
				[NSNumber numberWithFloat:0.7], QCPortAttributeDefaultValueKey,nil];

	
	if([key isEqualToString:@"inputSmokeScale"])
		return [NSDictionary dictionaryWithObjectsAndKeys:
				@"Smoke Scale", QCPortAttributeNameKey, 
				[NSNumber numberWithFloat:0.1], QCPortAttributeDefaultValueKey,nil];

	
	if([key isEqualToString:@"inputSmokeAlphaSpeed"])
		return [NSDictionary dictionaryWithObjectsAndKeys:
				@"Smoke Alpha Speed", QCPortAttributeNameKey, 
				[NSNumber numberWithFloat:-0.12], QCPortAttributeDefaultValueKey,nil];

	
	if([key isEqualToString:@"inputSmokeSpinRange"])
		return [NSDictionary dictionaryWithObjectsAndKeys:
				@"Smoke Spin Range", QCPortAttributeNameKey, 
				[NSNumber numberWithFloat:6], QCPortAttributeDefaultValueKey,nil];

	
	if([key isEqualToString:@"inputSmokeSpin"])
		return [NSDictionary dictionaryWithObjectsAndKeys:
				@"Smoke Spin", QCPortAttributeNameKey, 
				[NSNumber numberWithFloat:1], QCPortAttributeDefaultValueKey,nil];

	
	return nil;
}

+ (QCPlugInExecutionMode) executionMode
{
	/*
	Return the execution mode of the plug-in: kQCPlugInExecutionModeProvider, kQCPlugInExecutionModeProcessor, or kQCPlugInExecutionModeConsumer.
	*/
	
	return kQCPlugInExecutionModeConsumer;
}

+ (QCPlugInTimeMode) timeMode
{
	/*
	Return the time dependency mode of the plug-in: kQCPlugInTimeModeNone, kQCPlugInTimeModeIdle or kQCPlugInTimeModeTimeBase.
	*/
	
	return kQCPlugInTimeModeIdle;
}

- (id) init
{
	if(self = [super init]) {
		
	
		/*
		Allocate any permanent resource required by the plug-in.
		*/
	}
	
	return self;
}

- (void) finalize
{
	/*
	Release any non garbage collected resources created in -init.
	*/
	
	[super finalize];
}

- (void) dealloc
{
	/*
	Release any resources created in -init.
	*/
	
	[super dealloc];
}

+ (NSArray*) plugInKeys
{
	/*
	Return a list of the KVC keys corresponding to the internal settings of the plug-in.
	*/
	
	return nil;
}

- (id) serializedValueForKey:(NSString*)key;
{
	/*
	Provide custom serialization for the plug-in internal settings that are not values complying to the <NSCoding> protocol.
	The return object must be nil or a PList compatible i.e. NSString, NSNumber, NSDate, NSData, NSArray or NSDictionary.
	*/
	
	return [super serializedValueForKey:key];
}

- (void) setSerializedValue:(id)serializedValue forKey:(NSString*)key
{
	/*
	Provide deserialization for the plug-in internal settings that were custom serialized in -serializedValueForKey.
	Deserialize the value, then call [self setValue:value forKey:key] to set the corresponding internal setting of the plug-in instance to that deserialized value.
	*/
	
	[super setSerializedValue:serializedValue forKey:key];
}

- (QCPlugInViewController*) createViewController
{
	/*
	Return a new QCPlugInViewController to edit the internal settings of this plug-in instance.
	You can return a subclass of QCPlugInViewController if necessary.
	*/
	
	return [[QCPlugInViewController alloc] initWithPlugIn:self viewNibName:@"Settings"];
}

@end

@implementation firePlugIn (Execution)

- (BOOL) startExecution:(id<QCPlugInContext>)context
{
	/*
	Called by Quartz Composer when rendering of the composition starts: perform any required setup for the plug-in.
	Return NO in case of fatal failure (this will prevent rendering of the composition to start).
	*/
		
	return YES;
}

- (void) enableExecution:(id<QCPlugInContext>)context
{
	/*
	Called by Quartz Composer when the plug-in instance starts being used by Quartz Composer.
	*/
}

- (BOOL) execute:(id<QCPlugInContext>)context atTime:(NSTimeInterval)time withArguments:(NSDictionary*)arguments
{
	
		// Define a context and set it. This line causes OpenGL to use macros.
	CGLContextObj cgl_ctx = [context CGLContextObj];
	

	GLuint textureName;
	GLint saveMode;
	const CGFloat* colorComponents;
	GLenum error;
	if(cgl_ctx == NULL)
		return NO;
	
	
	
	float gas = self.inputGrow / 100.0;
	
	
	rootLayer = [CALayer layer];
	

	rootLayer.backgroundColor = CGColorGetConstantColor(kCGColorClear);
	
	
	
		//Create the fire emitter layer
	fireEmitter = [CAEmitterLayer layer];
	fireEmitter.emitterPosition = CGPointMake(self.inputEmitPixelXposFire, self.inputEmitPixelYposFire);
	fireEmitter.emitterMode = kCAEmitterLayerOutline;
	fireEmitter.emitterShape = kCAEmitterLayerLine;
	fireEmitter.renderMode = kCAEmitterLayerAdditive;
	fireEmitter.emitterSize = CGSizeMake(self.inputFireEmitterSizeWidth,  self.inputFireEmitterSizeHeight);
		
		//Create the smoke emitter layer
	smokeEmitter = [CAEmitterLayer layer];
	smokeEmitter.emitterPosition = CGPointMake(self.inputEmitPixelXposSmoke,self.inputEmitPixelYposSmoke );
	smokeEmitter.emitterMode = kCAEmitterLayerPoints;
	fireEmitter.emitterSize = CGSizeMake(self.inputSmokeEmitterSizeWidth, self.inputSmokeEmitterSizeHeight);
	
	
		//Create the fire emitter cell
	CAEmitterCell* fire = [CAEmitterCell emitterCell];
	fire.emissionLongitude = self.inputFireEmissionLongitude;
	fire.birthRate = self.inputFireBirthRate;
	fire.velocity = self.inputFireVelocity;
	fire.velocityRange = self.inputFireVelocityRange;
	fire.emissionRange = self.inputFireEmissionRange;
	fire.yAcceleration = self.inputFireYAcceleration;
	fire.xAcceleration = self.inputFireXAcceleration;
	fire.zAcceleration = self.inputFireZAcceleration;
	fire.lifetime = self.inputFireLifeTime;
	fire.lifetimeRange = self.inputFireLifeTimeRange;
	fire.scaleSpeed = self.inputFireScaleSpeed;
	fire.scale = self.inputFireScale;
	fire.alphaSpeed = -self.inputFireAlphaSpeed;
	CGColorRef color = self.inputFireColor;
	fire.color = color;
	CGColorRelease(color);
	fire.contents = self.inputFireImage;
	
		//Name the cell so that it can be animated later using keypaths
	[fire setName:@"fire"];
	
		//Add the fire emitter cell to the fire emitter layer
	fireEmitter.emitterCells = [NSArray arrayWithObject:fire] ;
	
		//Create the smoke emitter cell
	CAEmitterCell* smoke = [CAEmitterCell emitterCell];
	smoke.birthRate = self.inputSmokeBirthRate;
	smoke.emissionLongitude = self.inputSmokeEmissionLongitude;
	smoke.lifetime = self.inputSmokeLifeTime;
	smoke.lifetimeRange = self.inputSmokeLifeTimeRange;
	smoke.velocity = self.inputSmokeVelocity;
	smoke.velocityRange = self.inputSmokeVelocityRange;
	smoke.emissionRange = self.inputSmokeEmissionRange;
	smoke.spin = self.inputSmokeSpin;
	smoke.spinRange = self.inputSmokeSpinRange;
	smoke.yAcceleration = self.inputSmokeYAcceleration;
	smoke.xAcceleration = self.inputSmokeXAcceleration;
	smoke.zAcceleration = self.inputSmokeYAcceleration;
	smoke.contents = self.inputSmokeImage;
	smoke.scale = self.inputSmokeScale;
	smoke.alphaSpeed = -self.inputSmokeAlphaSpeed;
	smoke.scaleSpeed = self.inputSmokeScaleSpeed;
	
		//Name the cell so that it can be animated later using keypaths
	[smoke setName:@"smoke"];
	
		//Add the smoke emitter cell to the smoke emitter layer
	smokeEmitter.emitterCells = [NSArray arrayWithObject:smoke];
	
		//Add the two emitter layers to the root layer
	[rootLayer addSublayer:smokeEmitter];
	[rootLayer addSublayer:fireEmitter];
	

		//Set the view's layer to the base layer
	[imageView setLayer:rootLayer];
		[imageView setWantsLayer:YES];
	
		//Force the view to update
		[imageView setNeedsDisplay:YES];
	
		//Update the fire properties
	[fireEmitter setValue:[NSNumber numberWithInt:(gas * 1000)] forKeyPath:@"emitterCells.fire.birthrate"];
	[fireEmitter setValue:[NSNumber numberWithFloat:gas] forKeyPath:@"emitterCells.fire.lifetime"];
	[fireEmitter setValue:[NSNumber numberWithFloat:(gas * 0.35)] forKeyPath:@"emitterCells.fire.lifetimeRange"];
	fireEmitter.emitterSize = CGSizeMake(50 * gas, 0);
	
		//Update the smoke properites
	[smokeEmitter setValue:[NSNumber numberWithInt:gas * 4] forKeyPath:@"emitterCells.smoke.lifetime"];
	CGColorRef color2 = CGColorCreateGenericRGB(1, 1, 1, gas * 0.3);
	[smokeEmitter setValue:(id)color2 forKeyPath:@"emitterCells.smoke.color"];
	CGColorRelease(color2);
	
	CARenderer* car;
	
	
	
	
	
	car =[CARenderer rendererWithCGLContext:cgl_ctx options:arguments];
	car.layer = rootLayer;
		//[rootLayer renderInContext:cgl_ctx];
	
	

	if(imageView  && [imageView  lockTextureRepresentationWithColorSpace:([imageView
																 shouldColorMatch] ? [context colorSpace] :
																[imageView imageColorSpace])
													 forBounds:[imageView  imageBounds]])
		textureName = [imageView  textureName];
	else
		textureName = 0;
		// Save and set the modelview matrix.
	glGetIntegerv(GL_MATRIX_MODE, &saveMode);
	glMatrixMode(GL_MODELVIEW);
	glPushMatrix();
		// Translate the matrix
	glTranslatef(self.inputXpos, self.inputYpos, self.inputZpos);
		// Rotate the matrix
	glRotatef(self.inputAngle, 0.0, 1.0, 0.0);
		// Bind the texture to a texture unit
	if(textureName) {
		[imageView bindTextureRepresentationToCGLContext:cgl_ctx
										 textureUnit:GL_TEXTURE0
								normalizeCoordinates:YES];
	}
		// Get the color components (RGBA) from the input color port.
	colorComponents = CGColorGetComponents(self.inputColor);

	glColor4f(colorComponents[0], colorComponents[1], colorComponents[2],
			  colorComponents[3]);
		// Render the textured quad by mapping the texture coordinates to the vertices
	glBegin(GL_QUADS);
	glTexCoord2f(1.0, 1.0);
	glVertex3f(0.5, 0.5, 0); // upper right
	glTexCoord2f(0.0, 1.0);
	glVertex3f(-0.5, 0.5, 0); // upper left
	glTexCoord2f(0.0, 0.0);
	glVertex3f(-0.5, -0.5, 0); // lower left
	glTexCoord2f(1.0, 0.0);
	glVertex3f(0.5, -0.5, 0); // lower right
	glEnd();
		// Unbind the texture from the texture unit.
	if(textureName)
		[imageView  unbindTextureRepresentationFromCGLContext:cgl_ctx
											 textureUnit: GL_TEXTURE0];
		// Restore the modelview matrix.
	glMatrixMode(GL_MODELVIEW);
	glPopMatrix();
	glMatrixMode(saveMode);
		// Check for OpenGL errors and log them if there are errors.
	if(error = glGetError())
		[context logMessage:@"OpenGL error %04X", error];
		// Release the texture.
	if(textureName)
		[imageView unlockTextureRepresentation];
	return (error ? NO : YES);

}

- (void) disableExecution:(id<QCPlugInContext>)context
{
	
}

- (void) stopExecution:(id<QCPlugInContext>)context
{

}
/*
-(void)recursivelyRenderInContext:(id<QCPlugInContext>)context

{
		//[self renderAsVectorInContext:context];
	
	for (CALayer *currentSublayer in rootLayer)
	{
		CGContextSaveGState(layerContext);
		
			// Shift origin of context to match starting coordinate of sublayer
		CGPoint currentSublayerOrigin = currentSublayer.frame.origin;
		CGContextTranslateCTM (layerContext, currentSublayerOrigin.x, currentSublayerOrigin.y);
		[currentSublayer recursivelyRenderInContext:layerContext];
		CGContextRestoreGState(layerContext);
	}
}
*/

@end



